// Monetary Policy and Net Exports Externalities in the Small Open Economy (Jae Hun Shim)

@#define Total =0
@#define TP =0
@#define NTP =0
@#define YG =1


 
@#if Total == 1 
case_title='Total Welfare Loss Under ADT'; 
@#else 
@#if TP ==1 
case_title='TP Parts'; 
@#else
@#if NTP ==1 
case_title='NTP Parts'; 
@#else
@#if YG ==1 
case_title='YG Parts'; 
@#else
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 




var pht phn pdt nx sna ena sg eg og nxg pd yg yna rna at aht ahn e pt pn pi yf s x i pf y;


varexo yf_ pf_ aht_ ahn_ ;        
                                      // aht_ = shocks in tradable production productivity in SOE
								      // ahn_ = shocks in non-tradable production productivity in SOE									  
                                      // yf_ = shocks in foreign output
									  // pf_ = shocks in foreign inflation
									 

parameters sigaht sigahn lamda nu rhoaht rhoahn tayp tayy sigma alpha omega eta beta epsilon rho phi rhoyf rhopf theta;

sigaht = 0.0242;
sigahn = 0.0169;
nu = 0.8;
beta = 0.99;
sigma = 0.58;
alpha = 0.3/0.58;
lamda = 1 - alpha;
omega = 0.74;
eta = 1.5;
rho = 1;
epsilon = 6;
theta = 0.75;
phi = 3;

rhoaht = 0.61;
rhoahn = 0.52;
rhoyf = 0.89;
rhopf = 0.86;

tayp = 1.5;
tayy=0.125;



model(linear);

// net exports
nx = sigma*alpha*(eta - 1 + alpha*(omega*(1 - sigma) + sigma) + lamda*eta - 1)*s - sigma*alpha*(1-sigma)*(omega-1)*e;

// IS equation
yg = yg(+1) - (nx(+1) - nx) - (i - sigma*pt(+1) - (1-sigma)*pn(+1) - rna);

// Natural Level of Output
yna = ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/
(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*(1+phi)*at + 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*((1-(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) 
+ (sigma*alpha*(eta+lamda*(eta-omega)))))*yf - ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma))-
(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))*(1-sigma))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*ena;

// Natural Level of Terms of Trade
sna = (1/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*(yna - yf + (((sigma*alpha*(omega-1))+1)*(1-sigma))*ena);

// Natural Level of Relative Price
ena = aht - ahn;

// Definition of outout gap
yg = y - yna;

// Definition of relative price gap
eg = e - ena;

// Definition of terms of trade gap
sg = s - sna;

// Definition of open economy gap
og = sg - (1-sigma)*eg;

// Definition of net exports gap
nxg = yg - og;

// Nature Rate of Interest Rate 
rna = ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma)) - (((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*(1+(phi*sigma)))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha)
 + (sigma*alpha*(eta+lamda*(eta-omega)))))*aht*(1 - rhoaht) - 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma))+(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*phi*(1-sigma))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*ahn*(1-rhoahn) - 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*((1-(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega)))))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*yf*(1 - rhoyf);

// Domestic Tradable New Keynesian Philips Curve
pt   = ((1-beta*theta)*(1-theta)/theta)*(phi*yg + sg) + beta*pt(+1); 

// Definition of Tradable Inflation
pt = pht - pht(-1);

// Domestic Non-Tradable New Keynesian Philips Curve              
pn   = ((1-beta*theta)*(1-theta)/theta)*(phi*yg + sg - eg) + beta*pn(+1);

// Definition of Non-Tradable Inflation
pn = phn - phn(-1);                 

// CPI inflation
pi   = beta*pi(+1) + ((1-beta*theta)*(1-theta)/theta)*((1+phi)*yg - nxg) - sigma*alpha*(beta*(s(+1) - s) - (s-s(-1)));                      

// Definition of Terms of Trade
s = s(-1) + x - x(-1) + pf - pt;                                             

// Exogenous Process of Foreign Output
yf   = rhoyf*yf(-1) + yf_; 

// Exogenous Process of Foreign Inflation  
pf   = rhopf*pf(-1) + pf_;   

// Exogenous Process of Tradable Productivity                                                    
aht = rhoaht*aht(-1) + aht_;    

// Exogenous Process of Non-Tradable Productivity                                                       
ahn = rhoahn*ahn(-1) + ahn_;                                                          
 


i = nu*i(-1) + (1-nu)*tayp*pi;  
                                                                     

// Market Clearing Condition
y = yf + (((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*s - (((sigma*alpha*(omega-1))+1)*(1-sigma))*e;                                                                          

// Definition of Relative Home Producer Price
e = e(-1) - pt + pn;                                                                                                 

// Definition of Composite Domestic Inflation                   
pd = sigma*pt + (1-sigma)*pn;

// Definition of Domestic Inflation
pd = pdt - pdt(-1);

// Aggregate Productivity 
at = sigma*aht + (1 - sigma)*ahn;                                                         
end;


steady;
check;


///////////////////////////////////////////////////////////////////////////////////////////////////////

sigaht = 0.005;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');

@#if Total == 1 
V(1,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;


sigaht = 0.007;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.009;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.011;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.013;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.015;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');

@#if Total == 1 
V(1,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.017;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');

@#if Total == 1 
V(1,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.019;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.021;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.023;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 

@#if Total == 1 
V(1,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

sigaht = 0.025;


shocks;  
var aht_ = sigaht^2; //the standard deviation of productivity
var ahn_; stderr 0.005;
var yf_; stderr 0.005;

corr aht_, ahn_ = 0.5287;
corr aht_, yf_ = 0.4758;
corr ahn_, yf_ = 0.2318;
end;

stoch_simul(order=1, irf=0, irf_plot_threshold=0, noprint);
                                         
var_string={'pd', 'pn', 'yg', 'pt', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');
 
@#if Total == 1 
V(1,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 

@#if TP == 1 
V(1,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos)))*100;
@#else

@#if NTP == 1 
V(1,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*((1 - sigma)*oo_.var(pn_pos,pn_pos)))*100;
@#else 

@#if YG == 1 
V(1,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((1 + phi)*oo_.var(yg_pos,yg_pos))*100;
@#else 
error('One case must be set to 1') 
@#endif 
@#endif 
@#endif 
@#endif 

end;

@#if Total == 1
save('J_Total','V','M_','oo_','cyc_moments','options_','case_title');
@#else
@#if TP ==1
save('J_TP','V','M_','oo_','cyc_moments','options_','case_title');
@#else
@#if NTP ==1
save('J_NTP','V','M_','oo_','cyc_moments','options_','case_title');
@#else
@#if YG ==1
save('J_YG','V','M_','oo_','cyc_moments','options_','case_title');
@#else
error('Undefined case')
@#endif
@#endif
@#endif
@#endif



    Total=load('J_Total.mat'); 
    TP=load('J_TP.mat');
    NTP=load('J_NTP.mat');
    YG=load('J_YG.mat');



case_string={'sigaht = 0.005', 'sigaht = 0.007','sigaht = 0.009','sigaht = 0.011','sigaht = 0.013','sigaht = 0.015','sigaht = 0.017','sigaht = 0.019','sigaht = 0.021','sigaht = 0.023','sigaht = 0.025'};
    fprintf('\nTABLE 2: Contribution to welfare losses\n')
    fprintf('%20s \t %6s \t %6s \t %6s \t %6s \n','','Total','TP','NTP','YG')
    for case_iter=1:11
        fprintf('%-s \n',case_string{case_iter});
        fprintf('%-20s \t %5.4f \t %5.4f \t %5.4f \t %5.4f \n\n','T',Total.V(1,case_iter),TP.V(1,case_iter),NTP.V(1,case_iter),YG.V(1,case_iter))
        
end;




