// Monetary Policy and Net Exports Externalities in the Small Open Economy (Jae Hun Shim)




var pht phn pdt nx sna ena sg eg og nxg pd yg yna rna at aht ahn e pt pn pi yf s x i pf y;


varexo yf_ pf_ aht_ ahn_ ;        
                                      // aht_ = shocks in tradable production productivity in SOE
								      // ahn_ = shocks in non-tradable production productivity in SOE									  
                                      // yf_ = shocks in foreign output
									  // pf_ = shocks in foreign inflation
									 

parameters taynx sigaht sigahn taynx lamda nu rhoaht rhoahn tayp tayy sigma alpha omega eta beta epsilon rho phi rhoyf rhopf theta taypt taypn;

taynx = 0.125;
sigaht = 0.0242;
sigahn = 0.0169;

nu = 0.8;
beta = 0.99;
sigma = 0.58;
alpha = 0.3/0.58;
lamda = 1 - alpha;
omega = 0.74;
eta = 1.5;
rho = 1;
epsilon = 6;
theta = 0.75;
phi = 3;

rhoaht = 0.61;
rhoahn = 0.52;
rhoyf = 0.89;
rhopf = 0.86;

tayp = 1.5;
taypt = 1.5;
taypn = 1.5;
tayy=2;


model(linear);

// net exports
nx = sigma*alpha*(eta - 1 + alpha*(omega*(1 - sigma) + sigma) + lamda*eta - 1)*s - sigma*alpha*(1-sigma)*(omega-1)*e;

// IS equation
yg = yg(+1) - (nx(+1) - nx) - (i - sigma*pt(+1) - (1-sigma)*pn(+1) - rna);

// Natural Level of Output
yna = ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/
(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*(1+phi)*at + 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*((1-(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) 
+ (sigma*alpha*(eta+lamda*(eta-omega)))))*yf - ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma))-
(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))*(1-sigma))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*ena;

// Natural Level of Terms of Trade
sna = (1/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*(yna - yf + (((sigma*alpha*(omega-1))+1)*(1-sigma))*ena);

// Natural Level of Relative Price
ena = aht - ahn;

// Definition of outout gap
yg = y - yna;

// Definition of relative price gap
eg = e - ena;

// Definition of terms of trade gap
sg = s - sna;

// Definition of open economy gap
og = sg - (1-sigma)*eg;

// Definition of net exports gap
nxg = yg - og;

// Nature Rate of Interest Rate 
rna = ((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma)) - (((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*(1+(phi*sigma)))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha)
 + (sigma*alpha*(eta+lamda*(eta-omega)))))*aht*(1 - rhoaht) - 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))))*(((((sigma*alpha*(omega-1))+1)*(1-sigma))+(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*phi*(1-sigma))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*ahn*(1-rhoahn) - 
((((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega))))/(1+phi*(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))))*((1-(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + 
(sigma*alpha*(eta+lamda*(eta-omega)))))/(((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega)))))*yf*(1 - rhoyf);

// Domestic Tradable New Keynesian Philips Curve
pt   = ((1-beta*theta)*(1-theta)/theta)*(phi*yg + sg) + beta*pt(+1); 

// Definition of Tradable Inflation
pt = pht - pht(-1);

// Domestic Non-Tradable New Keynesian Philips Curve              
pn   = ((1-beta*theta)*(1-theta)/theta)*(phi*yg + sg - eg) + beta*pn(+1);

// Definition of Non-Tradable Inflation
pn = phn - phn(-1);                 

// CPI inflation
pi   = beta*pi(+1) + ((1-beta*theta)*(1-theta)/theta)*((1+phi)*yg - nxg) - sigma*alpha*(beta*(s(+1) - s) - (s-s(-1)));                      

// Definition of Terms of Trade
s = s(-1) + x - x(-1) + pf - pt;                                             

// Exogenous Process of Foreign Output
yf   = rhoyf*yf(-1) + yf_; 

// Exogenous Process of Foreign Inflation  
pf   = rhopf*pf(-1) + pf_;   

// Exogenous Process of Tradable Productivity                                                    
aht = rhoaht*aht(-1) + aht_;    

// Exogenous Process of Non-Tradable Productivity                                                       
ahn = rhoahn*ahn(-1) + ahn_;                                                          
 

// i = nu*i(-1) + (1-nu)*(tayp*(sigma*pt + (1-sigma)*pn) - taynx*nx + tayy*yg) ;  
   i = nu*i(-1) + (1-nu)*(taypt*pt + taypn*pn  + tayy*yg) ;  

                                                                     

// Market Clearing Condition
y = yf + (((sigma*alpha*(omega-1))+1)*(1-sigma*alpha) + (sigma*alpha*(eta+lamda*(eta-omega))))*s - (((sigma*alpha*(omega-1))+1)*(1-sigma))*e;                                                                          

// Definition of Relative Home Producer Price
e = e(-1) - pt + pn;                                                                                                 

// Definition of Composite Domestic Inflation                   
pd = sigma*pt + (1-sigma)*pn;

// Definition of Domestic Inflation
pd = pdt - pdt(-1);

// Aggregate Productivity 
at = sigma*aht + (1 - sigma)*ahn;                                                         
end;


steady;
check;

shocks;  
var ahn_; stderr 0.0169; 
end;

stoch_simul(order=1, irf=30, irf_plot_threshold=0, noprint);
                                         
var_string={'pt', 'pn', 'yg', 'pd', 'pi', 'og'};

for var_iter=1:length(var_string) 
var_pos=strmatch(var_string{var_iter},M_.endo_names,'exact'); 
cyc_moments(var_iter,1)=sqrt(oo_.var(var_pos,var_pos))*100; 
 

pt_pos=strmatch('pt',M_.endo_names,'exact');
pn_pos=strmatch('pn',M_.endo_names,'exact');
yg_pos=strmatch('yg',M_.endo_names,'exact');


nu = 0;
taypt =1.1;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(1,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(1,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(1,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(1,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(1,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(1,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(1,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(1,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(1,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(1,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(1,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(1,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(1,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(1,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(1,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(1,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(1,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(1,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(1,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(1,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(1,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(1,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(1,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(1,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(1,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(1,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(1,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.1;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(1,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(1,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(1,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(1,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(1,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.1;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(1,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.12;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(2,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(2,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(2,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(2,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(2,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(2,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(2,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(2,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(2,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(2,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(2,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(2,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(2,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(2,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(2,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(2,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(2,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(2,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(2,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(2,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(2,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(2,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(2,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(2,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(2,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(2,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(2,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.12;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(2,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(2,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(2,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(2,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(2,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.12;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(2,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.14;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(3,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(3,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(3,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(3,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(3,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(3,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(3,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(3,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(3,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(3,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(3,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(3,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(3,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(3,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(3,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(3,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(3,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(3,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(3,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(3,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(3,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(3,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(3,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(3,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(3,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(3,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(3,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.14;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(3,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(3,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(3,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(3,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(3,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.14;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(3,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.16;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(4,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(4,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(4,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(4,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(4,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(4,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(4,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(4,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(4,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(4,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(4,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(4,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(4,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(4,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(4,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(4,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(4,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(4,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(4,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(4,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(4,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(4,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(4,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(4,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(4,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(4,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(4,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.16;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(4,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(4,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(4,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(4,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(4,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.16;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(4,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.18;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(5,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(5,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(5,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(5,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(5,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(5,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(5,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(5,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(5,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(5,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(5,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(5,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(5,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(5,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(5,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(5,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(5,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(5,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(5,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(5,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(5,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(5,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(5,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(5,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(5,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(5,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(5,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.18;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(5,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(5,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(5,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(5,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(5,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.18;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(5,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.20;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(6,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(6,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(6,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(6,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(6,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(6,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(6,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(6,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(6,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(6,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(6,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(6,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(6,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(6,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(6,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(6,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(6,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(6,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(6,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(6,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(6,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(6,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(6,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(6,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(6,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(6,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(6,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.20;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(6,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(6,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(6,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(6,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(6,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.20;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(6,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.22;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(7,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(7,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(7,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(7,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(7,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(7,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(7,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(7,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(7,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(7,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(7,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(7,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(7,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(7,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(7,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(7,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(7,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(7,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(7,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(7,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(7,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(7,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(7,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(7,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(7,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(7,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(7,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.22;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(7,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(7,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(7,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(7,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(7,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.22;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(7,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.24;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(8,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(8,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(8,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(8,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(8,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(8,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(8,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(8,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(8,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(8,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(8,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(8,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(8,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(8,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(8,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(8,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(8,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(8,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(8,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(8,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(8,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(8,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(8,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(8,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(8,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(8,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(8,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.24;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(8,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(8,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(8,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(8,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(8,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.24;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(8,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.26;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(9,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(9,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(9,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(9,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(9,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(9,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(9,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(9,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(9,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(9,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(9,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(9,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(9,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(9,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(9,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(9,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(9,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(9,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(9,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(9,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(9,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(9,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(9,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(9,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(9,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(9,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(9,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.26;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(9,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(9,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(9,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(9,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(9,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.26;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(9,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.28;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(10,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(10,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(10,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(10,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(10,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(10,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(10,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(10,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(10,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(10,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(10,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(10,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(10,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(10,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(10,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(10,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(10,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(10,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(10,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(10,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(10,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(10,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(10,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(10,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(10,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(10,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(10,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.28;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(10,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(10,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(10,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(10,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(10,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.28;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(10,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.30;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(11,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(11,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(11,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(11,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(11,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(11,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(11,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(11,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(11,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(11,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(11,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(11,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(11,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(11,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(11,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(11,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(11,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(11,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(11,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(11,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(11,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(11,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(11,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(11,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(11,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(11,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(11,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.30;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(11,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(11,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(11,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(11,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(11,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.30;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(11,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.32;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(12,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(12,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(12,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(12,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(12,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(12,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(12,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(12,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(12,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(12,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(12,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(12,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(12,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(12,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(12,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(12,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(12,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(12,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(12,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(12,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(12,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(12,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(12,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(12,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(12,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(12,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(12,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.32;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(12,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(12,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(12,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(12,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(12,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.32;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(12,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.34;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(13,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(13,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(13,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(13,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(13,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(13,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(13,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(13,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(13,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(13,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(13,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(13,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(13,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(13,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(13,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(13,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(13,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(13,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(13,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(13,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(13,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(13,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(13,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(13,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(13,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(13,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(13,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.34;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(13,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(13,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(13,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(13,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(13,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.34;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(13,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.36;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(14,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(14,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(14,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(14,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(14,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(14,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(14,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(14,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(14,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(14,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(14,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(14,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(14,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(14,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(14,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(14,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(14,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(14,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(14,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(14,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(14,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(14,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(14,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(14,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(14,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(14,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(14,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.36;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(14,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(14,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(14,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(14,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(14,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.36;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(14,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.38;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(15,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(15,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(15,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(15,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(15,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(15,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(15,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(15,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(15,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(15,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(15,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(15,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(15,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(15,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(15,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(15,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(15,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(15,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(15,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(15,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(15,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(15,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(15,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(15,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(15,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(15,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(15,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.38;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(15,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(15,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(15,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(15,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(15,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.38;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(15,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.40;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(16,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(16,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(16,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(16,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(16,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(16,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(16,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(16,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(16,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(16,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(16,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(16,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(16,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(16,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(16,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(16,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(16,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(16,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(16,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(16,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(16,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(16,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(16,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(16,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(16,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(16,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(16,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.40;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(16,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(16,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(16,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(16,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(16,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.40;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(16,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.42;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(17,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(17,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(17,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(17,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(17,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(17,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(17,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(17,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(17,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(17,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(17,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(17,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(17,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(17,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(17,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(17,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(17,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(17,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(17,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(17,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(17,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(17,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(17,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(17,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(17,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(17,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(17,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.42;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(17,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(17,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(17,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(17,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(17,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.42;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(17,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.44;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(18,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(18,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(18,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(18,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(18,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(18,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(18,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(18,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(18,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(18,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(18,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(18,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(18,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(18,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(18,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(18,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(18,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(18,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(18,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(18,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(18,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(18,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(18,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(18,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(18,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(18,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(18,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.44;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(18,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(18,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(18,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(18,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(18,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.44;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(18,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.46;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(19,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(19,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(19,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(19,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(19,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(19,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(19,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(19,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(19,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(19,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(19,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(19,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(19,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(19,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(19,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(19,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(19,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(19,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(19,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(19,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(19,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(19,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(19,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(19,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(19,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(19,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(19,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.46;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(19,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(19,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(19,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(19,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(19,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.46;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(19,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.48;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(20,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(20,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(20,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(20,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(20,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(20,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(20,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(20,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(20,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(20,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(20,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(20,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(20,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(20,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(20,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(20,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(20,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(20,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(20,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(20,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(20,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(20,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(20,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(20,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(20,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(20,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(20,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.48;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(20,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(20,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(20,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(20,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(20,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.48;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(20,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.5;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(21,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(21,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(21,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(21,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(21,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(21,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(21,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(21,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(21,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(21,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(21,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(21,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(21,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(21,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(21,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(21,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(21,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(21,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(21,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(21,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(21,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(21,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(21,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(21,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(21,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(21,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(21,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.5;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(21,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(21,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(21,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(21,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(21,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.5;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(21,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.52;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(22,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(22,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(22,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(22,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(22,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(22,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(22,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(22,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(22,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(22,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(22,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(22,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(22,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(22,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(22,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(22,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(22,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(22,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(22,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(22,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(22,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(22,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(22,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(22,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(22,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(22,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(22,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.52;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(22,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(22,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(22,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(22,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(22,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.52;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(22,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.54;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(23,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(23,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(23,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(23,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(23,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(23,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(23,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(23,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(23,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(23,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(23,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(23,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(23,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(23,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(23,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(23,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(23,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(23,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(23,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(23,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(23,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(23,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(23,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(23,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(23,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(23,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(23,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.54;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(23,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(23,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(23,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(23,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(23,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.54;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(23,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.56;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(24,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(24,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(24,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(24,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(24,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(24,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(24,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(24,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(24,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(24,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(24,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(24,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(24,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(24,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(24,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(24,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(24,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(24,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(24,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(24,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(24,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(24,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(24,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(24,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(24,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(24,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(24,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.56;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(24,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(24,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(24,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(24,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(24,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.56;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(24,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.58;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(25,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(25,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(25,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(25,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(25,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(25,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(25,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(25,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(25,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(25,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(25,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(25,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(25,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(25,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(25,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(25,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(25,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(25,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(25,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(25,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(25,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(25,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(25,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(25,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(25,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(25,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(25,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.58;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(25,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(25,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(25,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(25,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(25,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.58;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(25,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.6;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(26,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(26,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(26,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(26,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(26,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(26,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(26,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(26,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(26,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(26,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(26,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(26,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(26,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(26,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(26,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(26,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(26,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(26,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(26,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(26,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(26,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(26,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(26,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(26,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(26,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(26,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(26,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.6;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(26,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(26,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(26,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(26,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(26,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.6;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(26,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.62;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(27,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(27,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(27,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(27,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(27,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(27,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(27,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(27,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(27,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(27,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(27,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(27,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(27,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(27,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(27,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(27,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(27,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(27,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(27,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(27,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(27,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(27,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(27,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(27,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(27,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(27,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(27,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.62;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(27,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(27,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(27,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(27,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(27,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.62;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(27,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.64;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(28,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(28,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(28,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(28,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(28,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(28,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(28,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(28,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(28,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(28,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(28,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(28,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(28,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(28,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(28,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(28,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(28,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(28,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(28,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(28,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(28,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(28,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(28,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(28,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(28,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(28,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(28,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.64;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(28,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(28,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(28,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(28,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(28,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.64;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(28,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.66;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(29,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(29,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(29,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(29,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(29,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(29,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(29,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(29,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(29,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(29,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(29,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(29,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(29,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(29,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(29,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(29,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(29,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(29,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(29,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(29,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(29,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(29,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(29,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(29,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(29,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(29,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(29,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.66;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(29,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(29,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(29,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(29,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(29,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.66;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(29,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.68;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(30,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(30,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(30,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(30,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(30,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(30,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(30,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(30,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(30,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(30,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(30,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(30,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(30,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(30,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(30,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(30,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(30,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(30,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(30,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(30,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(30,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(30,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(30,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(30,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(30,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(30,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(30,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.68;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(30,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(30,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(30,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(30,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(30,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.68;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(30,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.7;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(31,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(31,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(31,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(31,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(31,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(31,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(31,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(31,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(31,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(31,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(31,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(31,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(31,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(31,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(31,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(31,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(31,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(31,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(31,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(31,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(31,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(31,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(31,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(31,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(31,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(31,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(31,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.7;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(31,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(31,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(31,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(31,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(31,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.7;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(31,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.72;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(32,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(32,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(32,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(32,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(32,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(32,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(32,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(32,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(32,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(32,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(32,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(32,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(32,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(32,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(32,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(32,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(32,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(32,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(32,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(32,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(32,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(32,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(32,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(32,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(32,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(32,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(32,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.72;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(32,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(32,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(32,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(32,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(32,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.72;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(32,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//

nu = 0;
taypt =1.74;
taypn=1.1;

stoch_simul(order=1, irf=0, noprint);

V(33,1)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.12;

stoch_simul(order=1, irf=0, noprint);

V(33,2)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.14;

stoch_simul(order=1, irf=0, noprint);

V(33,3)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.16;

stoch_simul(order=1, irf=0, noprint);

V(33,4)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.18;

stoch_simul(order=1, irf=0, noprint);

V(33,5)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.20;

stoch_simul(order=1, irf=0, noprint);

V(33,6)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.22;

stoch_simul(order=1, irf=0, noprint);

V(33,7)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.24;

stoch_simul(order=1, irf=0, noprint);

V(33,8)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.26;

stoch_simul(order=1, irf=0, noprint);

V(33,9)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.28;

stoch_simul(order=1, irf=0, noprint);

V(33,10)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.30;

stoch_simul(order=1, irf=0, noprint);

V(33,11)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.32;

stoch_simul(order=1, irf=0, noprint);

V(33,12)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.34;

stoch_simul(order=1, irf=0, noprint);

V(33,13)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.36;

stoch_simul(order=1, irf=0, noprint);

V(33,14)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.38;

stoch_simul(order=1, irf=0, noprint);

V(33,15)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.40;

stoch_simul(order=1, irf=0, noprint);

V(33,16)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.42;

stoch_simul(order=1, irf=0, noprint);

V(33,17)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.44;

stoch_simul(order=1, irf=0, noprint);

V(33,18)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.46;

stoch_simul(order=1, irf=0, noprint);

V(33,19)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.48;

stoch_simul(order=1, irf=0, noprint);

V(33,20)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.50;

stoch_simul(order=1, irf=0, noprint);

V(33,21)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.52;

stoch_simul(order=1, irf=0, noprint);

V(33,22)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.54;

stoch_simul(order=1, irf=0, noprint);

V(33,23)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.56;

stoch_simul(order=1, irf=0, noprint);

V(33,24)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.58;

stoch_simul(order=1, irf=0, noprint);

V(33,25)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.60;

stoch_simul(order=1, irf=0, noprint);

V(33,26)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.62;

stoch_simul(order=1, irf=0, noprint);

V(33,27)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

nu = 0;
taypt =1.74;
taypn=1.64;

stoch_simul(order=1, irf=0, noprint);

V(33,28)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.66;

stoch_simul(order=1, irf=0, noprint);

V(33,29)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.68;

stoch_simul(order=1, irf=0, noprint);

V(33,30)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.70;

stoch_simul(order=1, irf=0, noprint);

V(33,31)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.72;

stoch_simul(order=1, irf=0, noprint);

V(33,32)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;


nu = 0;
taypt =1.74;
taypn=1.74;

stoch_simul(order=1, irf=0, noprint);

V(33,33)= (((1-sigma*alpha)/((1+(sigma*alpha*(omega-1)))*(1-sigma*alpha)+(sigma*alpha*(eta+lamda*(eta-omega)))))/2)*((epsilon/((1-beta*theta)*(1-theta)/theta))*(sigma*oo_.var(pt_pos,pt_pos) + (1 - sigma)*oo_.var(pn_pos,pn_pos)) + (1 + phi)*oo_.var(yg_pos,yg_pos))*100;

//
//



end;


